common.dump: filter out latest xfsdump version messages
[xfstests-dev.git] / 137
1 #! /bin/bash
2 # FSQA Test No. 137
3 #
4 # Test for NULL files problem
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2006 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24 # creator
25 owner=lachlan@sgi.com
26
27 seq=`basename $0`
28 echo "QA output created by $seq"
29
30 here=`pwd`
31 tmp=/tmp/$$
32 status=1    # failure is the default!
33 trap "_cleanup; exit \$status" 0 1 2 3 15
34
35 _cleanup()
36 {
37     _cleanup_testdir
38 }
39
40 # get standard environment, filters and checks
41 . ./common.rc
42 . ./common.filter
43
44 # real QA test starts here
45 _supported_fs xfs
46 _supported_os Linux IRIX
47
48 _setup_testdir
49 _require_scratch
50 _scratch_mkfs_xfs >/dev/null 2>&1
51 _scratch_mount
52
53 # create files
54 i=1;
55 while [ $i -lt 1000 ]
56 do
57         file=$SCRATCH_MNT/$i
58         xfs_io -f -c "pwrite -b 64k -S 0xff 0 64k" $file > /dev/null
59         if [ $? -ne 0 ]
60         then
61                 echo error creating/writing file $file
62                 exit
63         fi
64         let i=$i+1
65 done
66
67 # give the system a chance to write something out
68 sleep 10
69
70 src/godown $SCRATCH_MNT
71
72 umount $SCRATCH_MNT
73 _scratch_mount
74 umount $SCRATCH_MNT
75 if [ ! _check_scratch_fs ]
76 then
77         echo error detected in filesystem
78         exit
79 fi
80 _scratch_mount
81
82 # check file size and contents
83 i=1;
84 while [ $i -lt 1000 ]
85 do
86         file=$SCRATCH_MNT/$i
87         # if file does not exist, the create was not logged, skip it
88         if [ -e $file ]
89         then
90                 # if file size is zero it cannot be corrupt, skip it
91                 if [ -s $file ]
92                 then
93                         # if file has non-zero size but no extents then it's contents will be NULLs, bad.
94                         if xfs_bmap $file | grep 'no extents' > /dev/null
95                         then
96                                 echo corrupt file $file - non-zero size but no extents
97                         elif xfs_bmap $file | grep 'hole' > /dev/null
98                         then
99                                 echo corrupt file $file - contains holes
100                         else
101                                 rm -f $file
102                         fi
103                 else
104                         rm -f $file
105                 fi
106         fi
107         let i=$i+1
108 done
109
110 status=0
111 exit